package cmdconsts

import "gitlab.com/evatix-go/core/constants"

const (
	Export                                 = "export"
	SystemCtl                              = "systemctl"
	Service                                = "service"
	Apt                                    = "apt"
	AptGet                                 = "apt-get"
	AptMark                                = "apt-mark"
	AptInstall                             = "apt install"
	AptInstallYes                          = "apt install -y"
	AptGetInstallYes                       = "apt-get install -y"
	AptGetInstallNoRecommendsNoSuggestsYes = "apt-get install --no-install-recommends --no-install-suggests -y"
	AptGetRemovePurgeAutoRemoveYes         = "apt-get remove --purge --auto-remove -y"
	Upgrade                                = "upgrade"
	Start                                  = "start"
	Restart                                = "restart"
	Stop                                   = "stop"
	Reload                                 = "reload"
	Enable                                 = "enable"
	Disable                                = "disable"
	Status                                 = "status"
	SystemCtlStatus                        = "systemctl status"
	SystemCtlStart                         = "systemctl start"
	SystemCtlStop                          = "systemctl stop"
	SystemCtlRestart                       = "systemctl restart"
	SystemCtlReload                        = "systemctl reload"
	SystemCtlEnable                        = "systemctl enable"
	SystemCtlDisable                       = "systemctl disable"
	Ln                                     = "ln"
	LnHyphenS                              = "ln -s"
	LinkSourceForce                        = "ln -sf"
	Install                                = "install"
	AptUpdate                              = "apt update"
	AptGetUpdate                           = "apt-get update"
	AptUpgrade                             = "apt upgrade"
	AptUpdateYes                           = "apt update -y"
	AptGetUpdateYes                        = "apt-get update -y"
	AptUpgradeYes                          = "apt upgrade -y"
	PPAWithColon                           = "ppa:"
	AddAptRepository                       = "add-apt-repository -y"
	WGet                                   = "wget"
	Curl                                   = "curl"
	RmRf                                   = "rm -rf"
	Rm                                     = "rm"
	Nginx                                  = "nginx"
	CronTabs                               = "crontabs"
	Ethernet                               = "ethernet"
	Postgresql                             = "postgresql"
	CommandJoiner                          = "&& \\"
	AndLogic                               = "&&"
	AtSymbol                               = "@"
	CommandPiping                          = "||"
	Equal                                  = "="
	Crontab                                = "crontab"
	Touch                                  = "touch"
	DirectoryFlag                          = "-d"
	AddFlag                                = "-a"
	GroupFlag                              = "-G"
	HyphenA                                = "-a"
	HyphenC                                = "-c"
	HyphenD                                = "-d"
	HyphenE                                = "-e"
	HyphenF                                = "-f"
	HyphenCapsF                            = "-F"
	HyphenG                                = "-G"
	HyphenM                                = "-m"
	HyphenN                                = "-n"
	HyphenO                                = "-o"
	HyphenS                                = "-s"
	HyphenCapsR                            = "-R"
	HyphenL                                = "-l"
	HyphenU                                = "-U"
	HyphenZ                                = "-z"
	HyphenY                                = "-y"
	RecursiveCommandFlag                   = "-R"
	Chown                                  = "chown"
	ChGroup                                = "chgrp"
	Root                                   = "root"
	UserMod                                = "usermod"
	CronService                            = "cron"
	Aria2C                                 = "aria2c"
	Pwd                                    = "pwd"
	Pwsh                                   = "pwsh"
	BashDefaultPath                        = "/bin/bash"
	BashCommandline                        = "bash"
	NonInteractiveFlag                     = "-c"
	NonInteractiveCmdFlag                  = "/c"
	NonInteractivePerlFlag                 = "-e"
	ChmodCommand                           = "chmod"
	IPCommand                              = "ip"
	Address                                = "a"
	Route                                  = "r"
	INet                                   = "inet"
	Add                                    = "add"
	Echo                                   = "echo"
	Dev                                    = "dev"
	Show                                   = "show"
	Hostname                               = "hostname"
	HyphenI                                = "-I"
	NetPlan                                = "netplan"
	Generate                               = "generate"
	Apply                                  = "apply"
	NMCli                                  = "nmcli"
	Networking                             = "networking"
	On                                     = "on"
	Off                                    = "off"
	Ls                                     = "ls"
	Ping                                   = "ping"
	PacketCount                            = "packetCount"
	LossPercentage                         = "lossPercentage"
	TimeTaken                              = "timeTaken"
	Network                                = "network"
	NetworkManagerService                  = "NetworkManager.service"
	PureFtpServiceName                     = "pure-ftpd"
	PurePw                                 = "pure-pw"
	Passwd                                 = "passwd"
	InvalidExitCode                        = constants.MinInt
	SuccessfullyRunningExitCode            = 0
	ScriptsMultiLineJoiner                 = " && \\ \n" // " && \\ \n"
	SingleLineScriptsJoiner                = " && "      // " && "
	ChangeDirSpace                         = "cd "
	ScriptChainLine                        = " \\ \n"
	UserAdd                                = "useradd"
	Cut                                    = "cut"
	CutD                                   = "cut -d"
	UserDelete                             = "userdel"
	GetEntry                               = "getent"
	Xargs                                  = "xargs"
	Grep                                   = "grep"
	Group                                  = "group"
	Groups                                 = "groups"
	GroupMod                               = "groupmod"
	GroupAdd                               = "groupadd"
	GroupDelete                            = "groupdel"
	DelUser                                = "deluser"
	Chage                                  = "chage"
	Expire                                 = "--expire"
	Remove                                 = "remove"
	FlagExpire                             = "--expire"
	FlagPurge                              = "--purge"
	FlagAutoRemove                         = "--auto-remove"
	FlagPurgeAutoRemove                    = FlagPurge + " " + FlagAutoRemove
	FlagSystem                             = "--system"
	FlagShell                              = "--shell"
	FlagGID                                = "--gid"
	FlagUID                                = "--uid"
	FlagCompile                            = "--compile"
	FlagKeyServer                          = "--keyserver"
	FlagKeyServerOptions                   = "--keyserver-options"
	FlagNoInstallRecommends                = "--no-install-recommends"
	FlagNoInstallSuggests                  = "--no-install-suggests"
	FlagNonExistent                        = "/nonexistent"
	FlagYes                                = "-y"
	Sudo                                   = "sudo"
	Shadow                                 = "shadow"
	BinShell                               = constants.BinShellCmd
	ShellFalse                             = "/bin/false"
	DevNull                                = "/dev/null"
)
