package reqtype

import (
	"gitlab.com/evatix-go/core/coreimpl/enumimpl"
	"gitlab.com/evatix-go/core/internal/reflectinternal"
)

var (
	Ranges = [...]string{
		Uninitialized:                    "Uninitialized",
		Create:                           "Create",
		Read:                             "Read",
		Update:                           "Update",
		Delete:                           "Delete",
		Drop:                             "Drop",
		CreateOrUpdate:                   "CreateOrUpdate",
		ExistCheck:                       "ExistCheck",
		SkipOnExist:                      "SkipOnExist",
		CreateOrSkipOnExist:              "CreateOrSkipOnExist",
		UpdateOrSkipOnNonExist:           "UpdateOrSkipOnNonExist",
		DeleteOrSkipOnNonExist:           "DeleteOrSkipOnNonExist",
		DropOrSkipOnNonExist:             "DropOrSkipOnNonExist",
		UpdateOnExist:                    "UpdateOnExist",
		DropOnExist:                      "DropOnExist",
		DropCreate:                       "DropCreate",
		Append:                           "Append",
		AppendByCompare:                  "AppendByCompare",
		AppendByCompareWhereCommentFound: "AppendByCompareWhereCommentFound",
		AppendLinesByCompare:             "AppendLinesByCompare",
		AppendLines:                      "AppendLines",
		CreateOrAppend:                   "CreateOrAppend",
		Prepend:                          "Prepend",
		CreateOrPrepend:                  "CreateOrPrepend",
		PrependLines:                     "PrependLines",
		Rename:                           "Rename",
		Change:                           "Change",
		Merge:                            "Merge",
		MergeLines:                       "MergeLines",
		GetHttp:                          "GetHttp",
		PutHttp:                          "PutHttp",
		PostHttp:                         "PostHttp",
		DeleteHttp:                       "DeleteHttp",
		PatchHttp:                        "PatchHttp",
		Touch:                            "Touch",
		Start:                            "Start",
		Stop:                             "Stop",
		Restart:                          "Restart",
		Reload:                           "Reload",
		StopSleepStart:                   "StopSleepStart",
		Suspend:                          "Suspend",
		Pause:                            "Pause",
		Resumed:                          "Resumed",
		TryRestart3Times:                 "TryRestart3Times",
		TryRestart5Times:                 "TryRestart5Times",
		TryStart3Times:                   "TryStart3Times",
		TryStart5Times:                   "TryStart5Times",
		TryStop3Times:                    "TryStop3Times",
		TryStop5Times:                    "TryStop5Times",
		InheritOnly:                      "InheritOnly",
		InheritPlusOverride:              "InheritPlusOverride",
		DynamicAction:                    "DynamicAction",
	}

	RangesMap = map[string]Request{
		"Uninitialized":                    Uninitialized,
		"Create":                           Create,
		"Read":                             Read,
		"Update":                           Update,
		"Delete":                           Delete,
		"Drop":                             Drop,
		"CreateOrUpdate":                   CreateOrUpdate,
		"ExistCheck":                       ExistCheck,
		"SkipOnExist":                      SkipOnExist,
		"CreateOrSkipOnExist":              CreateOrSkipOnExist,
		"UpdateOrSkipOnNonExist":           UpdateOrSkipOnNonExist,
		"DeleteOrSkipOnNonExist":           DeleteOrSkipOnNonExist,
		"DropOrSkipOnNonExist":             DropOrSkipOnNonExist,
		"UpdateOnExist":                    UpdateOnExist,
		"DropOnExist":                      DropOnExist,
		"DropCreate":                       DropCreate,
		"Append":                           Append,
		"AppendByCompare":                  AppendByCompare,
		"AppendByCompareWhereCommentFound": AppendByCompareWhereCommentFound,
		"AppendLinesByCompare":             AppendLinesByCompare,
		"AppendLines":                      AppendLines,
		"CreateOrAppend":                   CreateOrAppend,
		"Prepend":                          Prepend,
		"CreateOrPrepend":                  CreateOrPrepend,
		"PrependLines":                     PrependLines,
		"Rename":                           Rename,
		"Change":                           Change,
		"Merge":                            Merge,
		"MergeLines":                       MergeLines,
		"GetHttp":                          GetHttp,
		"PutHttp":                          PutHttp,
		"PostHttp":                         PostHttp,
		"DeleteHttp":                       DeleteHttp,
		"PatchHttp":                        PatchHttp,
		"Touch":                            Touch,
		"Start":                            Start,
		"Stop":                             Stop,
		"Restart":                          Restart,
		"Reload":                           Reload,
		"StopSleepStart":                   StopSleepStart,
		"Suspend":                          Suspend,
		"Pause":                            Pause,
		"Resumed":                          Resumed,
		"TryRestart3Times":                 TryRestart3Times,
		"TryRestart5Times":                 TryRestart5Times,
		"TryStart3Times":                   TryStart3Times,
		"TryStart5Times":                   TryStart5Times,
		"TryStop3Times":                    TryStop3Times,
		"TryStop5Times":                    TryStop5Times,
		"InheritOnly":                      InheritOnly,
		"InheritPlusOverride":              InheritPlusOverride,
		"DynamicAction":                    DynamicAction,
	}

	BasicEnumImpl = enumimpl.NewBasicByteUsingIndexedSlice(
		reflectinternal.TypeName(Uninitialized),
		Ranges[:])
)
